net.sf.saxon.pattern

## Class ContentTypeTest

- java.lang.Object
- - net.sf.saxon.pattern.NodeTest
  - - net.sf.saxon.pattern.ContentTypeTest

- All Implemented Interfaces:
    Serializable, ItemType

      public class ContentTypeTest
      extends NodeTest

  NodeTest is an interface that enables a test of whether a node matches particular conditions. ContentTypeTest tests for an element or attribute node with a particular type annotation.
  Author:
    Michael H. Kay
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ContentTypeTest(int nodeKind, SchemaType schemaType, Configuration config, boolean nillable)` Create a ContentTypeTest

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(Object other)` Indicates whether some other object is "equal to" this one.
    `AtomicType` | `getAtomizedItemType()` Get the item type of the atomic values that will be produced when an item of this type is atomized (assuming that atomization succeeds)
    `SchemaType` | `getContentType()` Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes).
    `double` | `getDefaultPriority()` Determine the default priority of this node test when used on its own as a Pattern
    `int` | `getNodeKind()`
    `int` | `getNodeKindMask()` Get a mask indicating which kinds of nodes this NodeTest can match.
    `int` | `getPrimitiveType()` Determine the types of nodes to which this pattern applies.
    `SchemaType` | `getSchemaType()`
    `ItemType` | `getSuperType(TypeHierarchy th)` Get the type from which this item type is derived by restriction.
    `int` | `hashCode()` Returns a hash code value for the object.
    `boolean` | `isAtomizable()` Ask whether values of this type are atomizable
    `boolean` | `isNillable()` The test is nillable if a question mark was specified as the occurrence indicator
    `boolean` | `matches(int nodeKind, NodeName name, int annotation)` Test whether this node test is satisfied by a given node.
    `boolean` | `matches(NodeInfo node)` Test whether this node test is satisfied by a given node.
    `boolean` | `matches(TinyTree tree, int nodeNr)` Test whether this node test is satisfied by a given node on a TinyTree.
    `void` | `setNillable(boolean nillable)` Indicate whether nilled elements should be matched (the default is false)
    `String` | `toString()`
    `void` | `visitNamedSchemaComponents(SchemaComponentVisitor visitor)` Visit all the schema components used in this ItemType definition

    - ### Methods inherited from class net.sf.saxon.pattern.NodeTest

      `getFingerprint, getPrimitiveItemType, getRequiredNodeNames, isAtomicType, isPlainType, matches, matchesItem`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ContentTypeTest

          public ContentTypeTest(int nodeKind,
                         SchemaType schemaType,
                         Configuration config,
                         boolean nillable)

      Create a ContentTypeTest
      Parameters:
        `nodeKind` - the kind of nodes to be matched: always elements or attributes
        `schemaType` - the required type annotation, as a simple or complex schema type
        `config` - the Configuration, supplied because this KindTest needs access to schema information
        `nillable` - indicates whether an element with xsi:nil=true satisifies the test

  - ### Method Detail

    - #### setNillable

          public void setNillable(boolean nillable)

      Indicate whether nilled elements should be matched (the default is false)
      Parameters:
        `nillable` - true if nilled elements should be matched

    - #### isNillable

          public boolean isNillable()

      The test is nillable if a question mark was specified as the occurrence indicator
      Overrides:
        `isNillable` in class `NodeTest`
      Returns:
        true if the test is nillable

    - #### getSchemaType

          public SchemaType getSchemaType()

    - #### getNodeKind

          public int getNodeKind()

    - #### getSuperType

          public ItemType getSuperType(TypeHierarchy th)

      Description copied from class: `NodeTest`
      Get the type from which this item type is derived by restriction. This is the supertype in the XPath type heirarchy, as distinct from the Schema base type: this means that the supertype of xs:boolean is xs:anyAtomicType, whose supertype is item() (rather than xs:anySimpleType).

      In fact the concept of "supertype" is not really well-defined, because the types form a lattice rather than a hierarchy. The only real requirement on this function is that it returns a type that strictly subsumes this type, ideally as narrowly as possible.

      Specified by:
        `getSuperType` in interface `ItemType`
      Overrides:
        `getSuperType` in class `NodeTest`
      Parameters:
        `th` - the type hierarchy cache
      Returns:
        the supertype, or null if this type is item()

    - #### matches

          public boolean matches(int nodeKind,
                        NodeName name,
                        int annotation)

      Test whether this node test is satisfied by a given node. This method is only fully supported for a subset of NodeTests, because it doesn't provide all the information needed to evaluate all node tests. In particular (a) it can't be used to evaluate a node test of the form element(N,T) or schema-element(E) where it is necessary to know whether the node is nilled, and (b) it can't be used to evaluate a node test of the form document-node(element(X)). This in practice means that it is used (a) to evaluate the simple node tests found in the XPath 1.0 subset used in XML Schema, and (b) to evaluate node tests where the node kind is known to be an attribute.
      Specified by:
        `matches` in class `NodeTest`
      Parameters:
        `nodeKind` - The kind of node to be matched
        `name` - identifies the expanded name of the node to be matched. The value should be null for a node with no name.
        `annotation` - The actual content type of the node
      Returns:
        true if the node matches this node tst

    - #### matches

          public boolean matches(TinyTree tree,
                        int nodeNr)

      Test whether this node test is satisfied by a given node on a TinyTree. The node must be a document, element, text, comment, or processing instruction node. This method is provided so that when navigating a TinyTree a node can be rejected without actually instantiating a NodeInfo object.
      Overrides:
        `matches` in class `NodeTest`
      Parameters:
        `tree` - the TinyTree containing the node
        `nodeNr` - the number of the node within the TinyTree
      Returns:
        true if the node matches the NodeTest, otherwise false

    - #### matches

          public boolean matches(NodeInfo node)

      Test whether this node test is satisfied by a given node. This alternative method is used in the case of nodes where calculating the fingerprint is expensive, for example DOM or JDOM nodes.
      Overrides:
        `matches` in class `NodeTest`
      Parameters:
        `node` - the node to be matched
      Returns:
        true if the node test is satisfied by the supplied node, false otherwise

    - #### getDefaultPriority

          public final double getDefaultPriority()

      Determine the default priority of this node test when used on its own as a Pattern
      Returns:
        the default priority

    - #### getPrimitiveType

          public int getPrimitiveType()

      Determine the types of nodes to which this pattern applies. Used for optimisation.
      Specified by:
        `getPrimitiveType` in interface `ItemType`
      Overrides:
        `getPrimitiveType` in class `NodeTest`
      Returns:
        the type of node matched by this pattern. e.g. Type.ELEMENT or Type.TEXT

    - #### getNodeKindMask

          public int getNodeKindMask()

      Get a mask indicating which kinds of nodes this NodeTest can match. This is a combination of bits: 1<
      Overrides:
        `getNodeKindMask` in class `NodeTest`
      Returns:
        a combination of bits: 1<

    - #### getContentType

          public SchemaType getContentType()

      Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes). Return AnyType if there are no restrictions. The default implementation returns AnyType.
      Overrides:
        `getContentType` in class `NodeTest`
      Returns:
        the type annotation that all nodes matching this NodeTest must satisfy

    - #### getAtomizedItemType

          public AtomicType getAtomizedItemType()

      Get the item type of the atomic values that will be produced when an item of this type is atomized (assuming that atomization succeeds)
      Specified by:
        `getAtomizedItemType` in interface `ItemType`
      Overrides:
        `getAtomizedItemType` in class `NodeTest`
      Returns:
        the best available item type of the atomic values that will be produced when an item of this type is atomized, or null if it is known that atomization will throw an error.

    - #### isAtomizable

          public boolean isAtomizable()

      Ask whether values of this type are atomizable
      Specified by:
        `isAtomizable` in interface `ItemType`
      Overrides:
        `isAtomizable` in class `NodeTest`
      Returns:
        true unless it is known that these items will be elements with element-only content, in which case return false

    - #### visitNamedSchemaComponents

          public void visitNamedSchemaComponents(SchemaComponentVisitor visitor)
                                          throws XPathException

      Visit all the schema components used in this ItemType definition
      Specified by:
        `visitNamedSchemaComponents` in interface `ItemType`
      Overrides:
        `visitNamedSchemaComponents` in class `NodeTest`
      Parameters:
        `visitor` - the visitor class to be called when each component is visited
      Throws:
        `XPathException` - if an error occurs

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### hashCode

          public int hashCode()

      Returns a hash code value for the object.
      Overrides:
        `hashCode` in class `Object`

    - #### equals

          public boolean equals(Object other)

      Indicates whether some other object is "equal to" this one.
      Overrides:
        `equals` in class `Object`

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.